<!--
  - Pfarrplaner
  -
  - @package Pfarrplaner
  - @author Christoph Fischer <chris@toph.de>
  - @copyright (c) Christoph Fischer, https://christoph-fischer.org
  - @license https://www.gnu.org/licenses/gpl-3.0.txt GPL 3.0 or later
  - @link https://codeberg.org/pfarr.tools/pfarrplaner
  - @version git: $Id$
  -
  - Sponsored by: Evangelischer Kirchenbezirk Balingen, https://www.kirchenbezirk-balingen.de
  -
  - Pfarrplaner is based on the Laravel framework (https://laravel.com).
  - This file may contain code created by Laravel's scaffolding functions.
  -
  - This program is free software: you can redistribute it and/or modify
  - it under the terms of the GNU General Public License as published by
  - the Free Software Foundation, either version 3 of the License, or
  - (at your option) any later version.
  -
  - This program is distributed in the hope that it will be useful,
  - but WITHOUT ANY WARRANTY; without even the implied warranty of
  - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  - GNU General Public License for more details.
  -
  - You should have received a copy of the GNU General Public License
  - along with this program.  If not, see <http://www.gnu.org/licenses/>.
  -->

<template>
    <admin-layout title="Assistent wählen">
        <dataset v-slot="{ ds }"
                 :ds-data="inputs"
                 ds-sort-by="name"
                 :ds-search-in="['title', 'description', 'group']">
            <div class="row mb-3" :data-page-count="ds.dsPagecount">
                <div class="col-md-6 mb-2 mb-md-0">
                    <dataset-search ds-search-placeholder="Suchen..." ref="search" autofocus/>
                </div>
                <div class="col-md-6 text-end">
                    <dataset-show class="float-right" :ds-show-entries="showEntries"/>
                </div>
            </div>
            <div class="row">
                <div class="col-md-12">
                    <dataset-item class="form-row row mb-3">
                        <template #default="{ row, rowIndex }">
                            <div class="col-md-4">
                                <a @click.prevent.stop="createInput(row)" href="#" class="report-link">
                                    <card class="mb-2 report-card" title="Klicken, um diesen Assistenten zu wählen"
                                          @click="createInput(row)">
                                        <card-body>
                                            <h3 class="card-title mb-2" :title="`Index: ${rowIndex}`">
                                                <span class="mdi mdi-keyboard"></span> {{ row.name }}
                                            </h3>
                                            <div class="card-text mb-0 ps-4">{{ row.description }}</div>
                                        </card-body>
                                    </card>
                                </a>
                            </div>
                        </template>
                        <template #noDataFound>
                            <div class="col-md-12 pt-2">
                                <p class="text-center">No results found</p>
                            </div>
                        </template>
                    </dataset-item>
                </div>
            </div>
            <div class="d-flex flex-md-row flex-column justify-content-between align-items-center border-top pt-2">
                <dataset-info class="mb-2 mb-md-0"/>
                <dataset-pager/>
            </div>
        </dataset>
    </admin-layout>
</template>

<script>
import NavButton from "../../components/Ui/buttons/NavButton";
import CardBody from "../../components/Ui/cards/cardBody";
import Card from "../../components/Ui/cards/card";
import {Dataset, DatasetItem, DatasetSearch} from "vue-dataset";
import DatasetInfo from "../../components/Ui/dataset/DatasetInfo";
import DatasetPager from "../../components/Ui/dataset/DatasetPager";
import DatasetShow from "../../components/Ui/dataset/DatasetShow";
import CardHeader from "../../components/Ui/cards/cardHeader";

export default {
    name: "Index",
    props: ['inputs'],
    components: {
        CardHeader,
        NavButton, CardBody, Card,
        Dataset,
        DatasetItem,
        DatasetInfo,
        DatasetPager,
        DatasetSearch,
        DatasetShow
    },
    data() {
        return {
            showEntries: 25,
        }
    },
    methods: {
        createInput(input) {
            this.$inertia.get(route('inputs.setup', input.id));
        }
    }
}
</script>

<style scoped>
.report-card {
    cursor: pointer;
}

.report-card:hover {
    border-color: #80bdff;
    outline: 0;
    box-shadow: 0 0 0 0.2rem rgba(0, 123, 255, 0.25);
}

.report-card .card-body h3 {
    font-weight: bold;
    width: 100%;
    display: block;
}

a.report-link, a.report-link:hover {
    text-decoration: none;
    color: black;
}
</style>
